"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var BaseRouter_1 = __importStar(require("./BaseRouter"));
var ProxyRouter = /** @class */ (function (_super) {
    __extends(ProxyRouter, _super);
    function ProxyRouter() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    ProxyRouter.prototype._lookup = function (receivedMethod, receivedPath) {
        var mapKey = _super.prototype.getMapKey.call(this, { method: receivedMethod, path: receivedPath });
        return _super.prototype.get.call(this, mapKey);
    };
    ProxyRouter.prototype.lookup = function (receivedMethod, receivedPath) {
        var _a;
        var _this = this;
        var eventMapHandler = (_a = {},
            _a[BaseRouter_1.EVENTS.ALL_ROUTES_PROCESSED] = function () { return _this._lookup(receivedMethod, receivedPath); },
            _a);
        return _super.prototype.lookupInCustomRouter.call(this, eventMapHandler);
    };
    return ProxyRouter;
}(BaseRouter_1.default));
exports.default = ProxyRouter;
